Index: alpha/alpha/machdep.c
===================================================================
RCS file: /home/ncvs/src/sys/alpha/alpha/machdep.c,v
retrieving revision 1.133
diff -u -r1.133 machdep.c
--- alpha/alpha/machdep.c	2001/06/29 11:10:25	1.133
+++ alpha/alpha/machdep.c	2001/07/04 02:54:14
@@ -257,7 +257,6 @@
 	/*
 	 * Good {morning,afternoon,evening,night}.
 	 */
-	mtx_lock(&vm_mtx);
 	identifycpu();
 
 	/* startrtclock(); */
@@ -367,7 +366,6 @@
 	exec_map = kmem_suballoc(kernel_map, &minaddr, &maxaddr,
 				(16*(ARG_MAX+(PAGE_SIZE*3))));
 
-	mtx_unlock(&vm_mtx);
 	/*
 	 * XXX: Mbuf system machine-specific initializations should
 	 *      go here, if anywhere.
Index: alpha/alpha/mem.c
===================================================================
RCS file: /home/ncvs/src/sys/alpha/alpha/mem.c,v
retrieving revision 1.35
diff -u -r1.35 mem.c
--- alpha/alpha/mem.c	2001/05/21 16:04:24	1.35
+++ alpha/alpha/mem.c	2001/07/04 02:54:14
@@ -145,6 +145,8 @@
 	int error = 0, rw;
 	vm_offset_t addr, eaddr;
 
+	GIANT_REQUIRED;
+
 	while (uio->uio_resid > 0 && !error) {
 		iov = uio->uio_iov;
 		if (iov->iov_len == 0) {
@@ -190,19 +192,15 @@
 			 */
 			addr = trunc_page(v);
 			eaddr = round_page(v + c);
-			mtx_lock(&vm_mtx);
 			for (; addr < eaddr; addr += PAGE_SIZE) 
 				if (pmap_extract(kernel_pmap, addr) == 0) {
-					mtx_unlock(&vm_mtx);
 					return EFAULT;
 				}
 			if (!kernacc((caddr_t)v, c,
 			    uio->uio_rw == UIO_READ ? 
 			    VM_PROT_READ : VM_PROT_WRITE)) {
-				mtx_unlock(&vm_mtx);
 				return (EFAULT);
 			}
-			mtx_unlock(&vm_mtx);
 			error = uiomove((caddr_t)v, c, uio);
 			continue;
 		}
Index: alpha/alpha/trap.c
===================================================================
RCS file: /home/ncvs/src/sys/alpha/alpha/trap.c,v
retrieving revision 1.68
diff -u -r1.68 trap.c
--- alpha/alpha/trap.c	2001/06/29 19:51:31	1.68
+++ alpha/alpha/trap.c	2001/07/04 02:54:14
@@ -278,6 +278,8 @@
 	critical_exit(s);
 #endif
 
+	GIANT_REQUIRED;
+
 	cnt.v_trap++;
 	ucode = 0;
 	user = (framep->tf_regs[FRAME_PS] & ALPHA_PSL_USERMODE) != 0;
@@ -432,15 +434,8 @@
 		case ALPHA_MMCSR_FOE:
 		case ALPHA_MMCSR_FOW:
 		{
-			int hadvmlock;
-
-			hadvmlock = mtx_owned(&vm_mtx);
-			if (hadvmlock == 0)
-				mtx_lock(&vm_mtx);
 			pmap_emulate_reference(p, a0, user,
 			    a1 == ALPHA_MMCSR_FOW);
-			if (hadvmlock == 0)
-				mtx_unlock(&vm_mtx);
 			goto out;
 		}
 		case ALPHA_MMCSR_INVALTRANS:
Index: alpha/alpha/vm_machdep.c
===================================================================
RCS file: /home/ncvs/src/sys/alpha/alpha/vm_machdep.c,v
retrieving revision 1.52
diff -u -r1.52 vm_machdep.c
--- alpha/alpha/vm_machdep.c	2001/07/03 05:09:37	1.52
+++ alpha/alpha/vm_machdep.c	2001/07/04 02:54:14
@@ -274,14 +274,13 @@
 cpu_wait(p)
 	struct proc *p;
 {
+	GIANT_REQUIRED;
 	
-	mtx_lock(&vm_mtx);
 	/* drop per-process resources */
 	pmap_dispose_proc(p);
 
 	/* and clean-out the vmspace */
 	vmspace_free(p->p_vmspace);
-	mtx_unlock(&vm_mtx);
 }
 
 /*
@@ -330,10 +329,11 @@
 	register caddr_t addr, v, kva;
 	vm_offset_t pa;
 
+	GIANT_REQUIRED;
+
 	if ((bp->b_flags & B_PHYS) == 0)
 		panic("vmapbuf");
 
-	mtx_lock(&vm_mtx);
 	for (v = bp->b_saveaddr, addr = (caddr_t)trunc_page(bp->b_data);
 	    addr < bp->b_data + bp->b_bufsize;
 	    addr += PAGE_SIZE, v += PAGE_SIZE) {
@@ -349,7 +349,6 @@
 		vm_page_hold(PHYS_TO_VM_PAGE(pa));
 		pmap_kenter((vm_offset_t) v, pa);
 	}
-	mtx_unlock(&vm_mtx);
 
 	kva = bp->b_saveaddr;
 	bp->b_saveaddr = bp->b_data;
@@ -367,10 +366,11 @@
 	register caddr_t addr;
 	vm_offset_t pa;
 
+	GIANT_REQUIRED;
+
 	if ((bp->b_flags & B_PHYS) == 0)
 		panic("vunmapbuf");
 
-	mtx_lock(&vm_mtx);
 	for (addr = (caddr_t)trunc_page(bp->b_data);
 	    addr < bp->b_data + bp->b_bufsize;
 	    addr += PAGE_SIZE) {
@@ -378,7 +378,6 @@
 		pmap_kremove((vm_offset_t) addr);
 		vm_page_unhold(PHYS_TO_VM_PAGE(pa));
 	}
-	mtx_unlock(&vm_mtx);
 
 	bp->b_data = bp->b_saveaddr;
 }
@@ -436,17 +435,13 @@
          * pages because doing so may flush our L1 and L2 caches too much.
 	 */
 
-	if (mtx_trylock(&vm_mtx) == 0)
-		return (0);
 	if (zero_state && vm_page_zero_count >= ZIDLE_LO(cnt.v_free_count)) {
-		mtx_unlock(&vm_mtx);
 		return(0);
 	}		
 	if (vm_page_zero_count >= ZIDLE_HI(cnt.v_free_count)) {
-		mtx_unlock(&vm_mtx);
 		return(0);
 	}
-
+	if (mtx_trylock(&Giant)) {
 		s = splvm();
 		m = vm_page_list_find(PQ_FREE, free_rover, FALSE);
 		zero_state = 0;
@@ -469,8 +464,9 @@
 		}
 		free_rover = (free_rover + PQ_PRIME2) & PQ_L2_MASK;
 		splx(s);
-		mtx_unlock(&vm_mtx);
 		return (1);
+	}
+	return(0);
 }
 
 /*
Index: alpha/osf1/imgact_osf1.c
===================================================================
RCS file: /home/ncvs/src/sys/alpha/osf1/imgact_osf1.c,v
retrieving revision 1.6
diff -u -r1.6 imgact_osf1.c
--- alpha/osf1/imgact_osf1.c	2001/06/06 13:46:16	1.6
+++ alpha/osf1/imgact_osf1.c	2001/07/04 02:54:14
@@ -97,6 +97,8 @@
 	struct nameidata *ndp;
 	Osf_Auxargs *osf_auxargs;
 
+	GIANT_REQUIRED;
+
 	execp = (const struct ecoff_exechdr*)imgp->image_header;
 	eap = &execp->a;
 	ndp = NULL;
@@ -175,14 +177,12 @@
 	/*
 	 * Destroy old process VM and create a new one (with a new stack).
 	 */
-	mtx_lock(&vm_mtx);
 	exec_new_vmspace(imgp);
 
 	/*
 	 * The vm space can now be changed.
 	 */
 	vmspace = imgp->proc->p_vmspace;
-	mtx_unlock(&vm_mtx);
 
 	imgp->interpreted = 0;
 	imgp->proc->p_sysent = &osf1_sysvec;
@@ -214,17 +214,14 @@
 	/* .. bss .. */
 	if (round_page(bsize)) {
 		baddr = bss_start;
-		mtx_lock(&vm_mtx);
 		if ((error = vm_map_find(&vmspace->vm_map, NULL,
 		    (vm_offset_t) 0, &baddr, round_page(bsize), FALSE,
 		    VM_PROT_ALL, VM_PROT_ALL, FALSE))) {
-			mtx_unlock(&vm_mtx);
 			DPRINTF(("%s(%d): error = %d\n", __FILE__, __LINE__,
 			    error));
 			goto bail;
 
 		}
-		mtx_unlock(&vm_mtx);
 	}
 	
 
Index: alpha/osf1/osf1_misc.c
===================================================================
RCS file: /home/ncvs/src/sys/alpha/osf1/osf1_misc.c,v
retrieving revision 1.16
diff -u -r1.16 osf1_misc.c
--- alpha/osf1/osf1_misc.c	2001/06/06 14:07:52	1.16
+++ alpha/osf1/osf1_misc.c	2001/07/04 02:54:14
@@ -472,6 +472,8 @@
 	vm_map_t map;
 	vm_offset_t addr, len, newaddr;
 
+	GIANT_REQUIRED;
+
 	SCARG(&a, addr) = SCARG(uap, addr);
 	SCARG(&a, len) = SCARG(uap, len);
 	SCARG(&a, prot) = SCARG(uap, prot);
@@ -500,7 +502,6 @@
 		addr = round_page((vm_offset_t)0x10000UL);
 	len = (vm_offset_t)SCARG(&a, len);
 	map = &p->p_vmspace->vm_map;
-	mtx_lock(&vm_mtx);
 	if (!vm_map_findspace(map, addr, len, &newaddr)) {
 		SCARG(&a,addr) = (caddr_t) newaddr;
 		SCARG(&a, flags) |= (MAP_FIXED);
@@ -510,7 +511,6 @@
 		uprintf("osf1_mmap:vm_map_findspace failed for: %p 0x%lx\n",
 		    (caddr_t)addr, len);
 #endif
-	mtx_unlock(&vm_mtx);
 	if (SCARG(uap, flags) & OSF1_MAP_SHARED)
 		SCARG(&a, flags) |= MAP_SHARED;
 	if (SCARG(uap, flags) & OSF1_MAP_PRIVATE)
@@ -1643,15 +1643,15 @@
 	vm_map_entry_t entry;
 	vm_offset_t zero;
 
+	GIANT_REQUIRED;
+
 	zero = 0;
 
 	if (uap->cmd == OSF1_USC_GET) {
-		mtx_lock(&vm_mtx);
 		if (vm_map_lookup_entry(&(p->p_vmspace->vm_map),0, &entry))
 			p->p_retval[0] =  OSF1_USW_NULLP;
 		else
 			p->p_retval[0] =  0;
-		mtx_unlock(&vm_mtx);
 		return(KERN_SUCCESS);
 	} else if (uap->cmd == OSF1_USC_SET)
 		if (uap->mask & OSF1_USW_NULLP) {
Index: dev/md/md.c
===================================================================
RCS file: /home/ncvs/src/sys/dev/md/md.c,v
retrieving revision 1.36
diff -u -r1.36 md.c
--- dev/md/md.c	2001/06/25 18:24:52	1.36
+++ dev/md/md.c	2001/07/04 02:54:14
@@ -692,6 +692,8 @@
 {
 	unsigned u;
 
+	GIANT_REQUIRED;
+
 	if (sc->dev != NULL) {
 		devstat_remove_entry(&sc->stats);
 		disk_destroy(sc->dev);
@@ -701,9 +703,7 @@
 	if (sc->cred != NULL)
 		crfree(sc->cred);
 	if (sc->object != NULL) {
-		mtx_lock(&vm_mtx);
 		vm_pager_deallocate(sc->object);
-		mtx_unlock(&vm_mtx);
 	}
 	if (sc->secp != NULL) {
 		for (u = 0; u < sc->nsect; u++) 
@@ -725,6 +725,8 @@
 	int error;
 	struct md_s *sc;
 
+	GIANT_REQUIRED;
+
 	if (mdio->md_options & MD_AUTOUNIT) {
 		sc = mdnew(-1);
 		mdio->md_unit = sc->unit;
@@ -757,18 +759,15 @@
 
 	sc->secsize = PAGE_SIZE;
 	sc->nsect = mdio->md_size / (PAGE_SIZE / DEV_BSIZE);
-	mtx_lock(&vm_mtx);
 	sc->object = vm_pager_allocate(OBJT_SWAP, NULL, sc->secsize * (vm_offset_t)sc->nsect, VM_PROT_DEFAULT, 0);
 	if (mdio->md_options & MD_RESERVE) {
 		if (swap_pager_reserve(sc->object, 0, sc->nsect) < 0) {
 			vm_pager_deallocate(sc->object);
-			mtx_unlock(&vm_mtx);
 			sc->object = NULL;
 			mddestroy(sc, mdio, p);
 			return(EDOM);
 		}
 	}
-	mtx_unlock(&vm_mtx);
 	error = mdsetcred(sc, p->p_ucred);
 	if (error)
 		mddestroy(sc, mdio, p);
Index: fs/procfs/procfs_map.c
===================================================================
RCS file: /home/ncvs/src/sys/fs/procfs/procfs_map.c,v
retrieving revision 1.28
diff -u -r1.28 procfs_map.c
--- fs/procfs/procfs_map.c	2001/06/06 04:13:11	1.28
+++ fs/procfs/procfs_map.c	2001/07/04 02:54:14
@@ -81,14 +81,14 @@
 	vm_map_entry_t entry;
 	char mebuffer[MEBUFFERSIZE];
 
+	GIANT_REQUIRED;
+
 	if (uio->uio_rw != UIO_READ)
 		return (EOPNOTSUPP);
 
 	if (uio->uio_offset != 0)
 		return (0);
 	
-	mtx_lock(&vm_mtx);
-
 	error = 0;
 	if (map != &curproc->p_vmspace->vm_map)
 		vm_map_lock_read(map);
@@ -171,17 +171,13 @@
 			error = EFBIG;
 			break;
 		}
-		mtx_unlock(&vm_mtx);
 		error = uiomove(mebuffer, len, uio);
-		mtx_lock(&vm_mtx);
 		if (error)
 			break;
 	}
 	if (map != &curproc->p_vmspace->vm_map)
 		vm_map_unlock_read(map);
 	
-	mtx_unlock(&vm_mtx);
-
 	return error;
 }
 
Index: fs/procfs/procfs_mem.c
===================================================================
RCS file: /home/ncvs/src/sys/fs/procfs/procfs_mem.c,v
retrieving revision 1.50
diff -u -r1.50 procfs_mem.c
--- fs/procfs/procfs_mem.c	2001/05/23 09:42:11	1.50
+++ fs/procfs/procfs_mem.c	2001/07/04 02:54:14
@@ -83,6 +83,8 @@
 	vm_prot_t reqprot;
 	vm_offset_t kva;
 
+	GIANT_REQUIRED;
+
 	/*
 	 * if the vmspace is in the midst of being deallocated or the
 	 * process is exiting, don't try to grab anything.  The page table
@@ -91,12 +93,8 @@
 	vm = p->p_vmspace;
 	if ((p->p_flag & P_WEXIT))
 		return EFAULT;
-
-	mtx_lock(&vm_mtx);
-	if (vm->vm_refcnt < 1) {
-		mtx_unlock(&vm_mtx);
+	if (vm->vm_refcnt < 1)
 		return EFAULT;
-	}
 	++vm->vm_refcnt;
 	/*
 	 * The map we want...
@@ -214,9 +212,7 @@
 		/*
 		 * Now do the i/o move.
 		 */
-		mtx_unlock(&vm_mtx);
 		error = uiomove((caddr_t)(kva + page_offset), len, uio);
-		mtx_lock(&vm_mtx);
 
 		pmap_kremove(kva);
 
@@ -235,7 +231,6 @@
 
 	kmem_free(kernel_map, kva, PAGE_SIZE);
 	vmspace_free(vm);
-	mtx_unlock(&vm_mtx);
 	return (error);
 }
 
Index: fs/specfs/spec_vnops.c
===================================================================
RCS file: /home/ncvs/src/sys/fs/specfs/spec_vnops.c,v
retrieving revision 1.159
diff -u -r1.159 spec_vnops.c
--- fs/specfs/spec_vnops.c	2001/05/23 22:20:29	1.159
+++ fs/specfs/spec_vnops.c	2001/07/04 02:54:14
@@ -660,7 +660,8 @@
 	int blksiz;
 	int gotreqpage;
 
-	mtx_assert(&Giant, MA_OWNED);
+	GIANT_REQUIRED;
+
 	error = 0;
 	pcount = round_page(ap->a_count) / PAGE_SIZE;
 
@@ -732,7 +733,6 @@
 	cnt.v_vnodein++;
 	cnt.v_vnodepgsin += pcount;
 
-	mtx_unlock(&vm_mtx);
 	/* Do the input. */
 	BUF_STRATEGY(bp);
 
@@ -743,7 +743,6 @@
 		tsleep(bp, PVM, "spread", 0);
 
 	splx(s);
-	mtx_lock(&vm_mtx);
 
 	if ((bp->b_ioflags & BIO_ERROR) != 0) {
 		if (bp->b_error)
Index: i386/i386/busdma_machdep.c
===================================================================
RCS file: /home/ncvs/src/sys/i386/i386/busdma_machdep.c,v
retrieving revision 1.22
diff -u -r1.22 busdma_machdep.c
--- i386/i386/busdma_machdep.c	2001/05/19 01:28:01	1.22
+++ i386/i386/busdma_machdep.c	2001/07/04 02:54:14
@@ -32,6 +32,7 @@
 #include <sys/bus.h>
 #include <sys/interrupt.h>
 #include <sys/lock.h>
+#include <sys/proc.h>
 #include <sys/mutex.h>
 
 #include <vm/vm.h>
Index: i386/i386/machdep.c
===================================================================
RCS file: /home/ncvs/src/sys/i386/i386/machdep.c,v
retrieving revision 1.459
diff -u -r1.459 machdep.c
--- i386/i386/machdep.c	2001/06/29 18:13:30	1.459
+++ i386/i386/machdep.c	2001/07/04 02:54:14
@@ -260,7 +260,6 @@
 	/*
 	 * Good {morning,afternoon,evening,night}.
 	 */
-	mtx_lock(&vm_mtx);
 	earlysetcpuclass();
 	startrtclock();
 	printcpuinfo();
@@ -394,7 +393,6 @@
 	exec_map = kmem_suballoc(kernel_map, &minaddr, &maxaddr,
 				(16*(ARG_MAX+(PAGE_SIZE*3))));
 
-	mtx_unlock(&vm_mtx);
 	/*
 	 * XXX: Mbuf system machine-specific initializations should
 	 *      go here, if anywhere.
@@ -2049,6 +2047,8 @@
 	if (!has_f00f_bug)
 		return;
 
+	GIANT_REQUIRED;
+
 	printf("Intel Pentium detected, installing workaround for F00F bug\n");
 
 	r_idt.rd_limit = sizeof(idt0) - 1;
@@ -2064,11 +2064,9 @@
 	r_idt.rd_base = (int)new_idt;
 	lidt(&r_idt);
 	idt = new_idt;
-	mtx_lock(&vm_mtx);
 	if (vm_map_protect(kernel_map, tmp, tmp + PAGE_SIZE,
 			   VM_PROT_READ, FALSE) != KERN_SUCCESS)
 		panic("vm_map_protect failed");
-	mtx_unlock(&vm_mtx);
 	return;
 }
 #endif /* defined(I586_CPU) && !NO_F00F_HACK */
Index: i386/i386/mem.c
===================================================================
RCS file: /home/ncvs/src/sys/i386/i386/mem.c,v
retrieving revision 1.91
diff -u -r1.91 mem.c
--- i386/i386/mem.c	2001/06/29 11:10:28	1.91
+++ i386/i386/mem.c	2001/07/04 02:54:14
@@ -140,6 +140,8 @@
 	int error = 0;
 	vm_offset_t addr, eaddr;
 
+	GIANT_REQUIRED;
+
 	while (uio->uio_resid > 0 && error == 0) {
 		iov = uio->uio_iov;
 		if (iov->iov_len == 0) {
@@ -155,17 +157,13 @@
 		case 0:
 			v = uio->uio_offset;
 			v &= ~PAGE_MASK;
-			mtx_lock(&vm_mtx);
 			pmap_kenter((vm_offset_t)ptvmmap, v);
-			mtx_unlock(&vm_mtx);
 			o = (int)uio->uio_offset & PAGE_MASK;
 			c = (u_int)(PAGE_SIZE - ((int)iov->iov_base & PAGE_MASK));
 			c = min(c, (u_int)(PAGE_SIZE - o));
 			c = min(c, (u_int)iov->iov_len);
 			error = uiomove((caddr_t)&ptvmmap[o], (int)c, uio);
-			mtx_lock(&vm_mtx);
 			pmap_kremove((vm_offset_t)ptvmmap);
-			mtx_unlock(&vm_mtx);
 			continue;
 
 /* minor device 1 is kernel memory */
@@ -183,20 +181,16 @@
 				return EFAULT;
 			if (eaddr >= (vm_offset_t)VADDR(APTDPTDI, 0))
 				return EFAULT;
-			mtx_lock(&vm_mtx);
 			for (; addr < eaddr; addr += PAGE_SIZE) 
 				if (pmap_extract(kernel_pmap, addr) == 0) {
-					mtx_unlock(&vm_mtx);
 					return EFAULT;
 				}
 
 			if (!kernacc((caddr_t)(int)uio->uio_offset, c,
 			    uio->uio_rw == UIO_READ ? 
 			    VM_PROT_READ : VM_PROT_WRITE)) {
-				mtx_unlock(&vm_mtx);
 				return (EFAULT);
 			}
-			mtx_unlock(&vm_mtx);
 			error = uiomove((caddr_t)(int)uio->uio_offset, (int)c, uio);
 			continue;
 		}
Index: i386/i386/pmap.c
===================================================================
RCS file: /home/ncvs/src/sys/i386/i386/pmap.c,v
retrieving revision 1.282
diff -u -r1.282 pmap.c
--- i386/i386/pmap.c	2001/05/23 22:17:28	1.282
+++ i386/i386/pmap.c	2001/07/04 02:54:15
@@ -3135,14 +3135,11 @@
 {
 	vm_offset_t va, tmpva, offset;
 	unsigned *pte;
-	int hadvmlock;
 
 	offset = pa & PAGE_MASK;
 	size = roundup(offset + size, PAGE_SIZE);
 
-	hadvmlock = mtx_owned(&vm_mtx);
-	if (!hadvmlock)
-		mtx_lock(&vm_mtx);
+	GIANT_REQUIRED;
 
 	va = kmem_alloc_pageable(kernel_map, size);
 	if (!va)
@@ -3157,9 +3154,6 @@
 		pa += PAGE_SIZE;
 	}
 	invltlb();
-
-	if (!hadvmlock)
-		mtx_unlock(&vm_mtx);
 
 	return ((void *)(va + offset));
 }
Index: i386/i386/vm_machdep.c
===================================================================
RCS file: /home/ncvs/src/sys/i386/i386/vm_machdep.c,v
retrieving revision 1.163
diff -u -r1.163 vm_machdep.c
--- i386/i386/vm_machdep.c	2001/07/03 05:09:44	1.163
+++ i386/i386/vm_machdep.c	2001/07/04 02:54:15
@@ -292,14 +292,13 @@
 cpu_wait(p)
 	struct proc *p;
 {
+	GIANT_REQUIRED;
 
-	mtx_lock(&vm_mtx);
 	/* drop per-process resources */
 	pmap_dispose_proc(p);
 
 	/* and clean-out the vmspace */
 	vmspace_free(p->p_vmspace);
-	mtx_unlock(&vm_mtx);
 }
 
 /*
@@ -378,10 +377,11 @@
 	register caddr_t addr, v, kva;
 	vm_offset_t pa;
 
+	GIANT_REQUIRED;
+
 	if ((bp->b_flags & B_PHYS) == 0)
 		panic("vmapbuf");
 
-	mtx_lock(&vm_mtx);
 	for (v = bp->b_saveaddr, addr = (caddr_t)trunc_page((vm_offset_t)bp->b_data);
 	    addr < bp->b_data + bp->b_bufsize;
 	    addr += PAGE_SIZE, v += PAGE_SIZE) {
@@ -397,7 +397,6 @@
 		vm_page_hold(PHYS_TO_VM_PAGE(pa));
 		pmap_kenter((vm_offset_t) v, pa);
 	}
-	mtx_unlock(&vm_mtx);
 
 	kva = bp->b_saveaddr;
 	bp->b_saveaddr = bp->b_data;
@@ -415,10 +414,11 @@
 	register caddr_t addr;
 	vm_offset_t pa;
 
+	GIANT_REQUIRED;
+
 	if ((bp->b_flags & B_PHYS) == 0)
 		panic("vunmapbuf");
 
-	mtx_lock(&vm_mtx);
 	for (addr = (caddr_t)trunc_page((vm_offset_t)bp->b_data);
 	    addr < bp->b_data + bp->b_bufsize;
 	    addr += PAGE_SIZE) {
@@ -426,7 +426,6 @@
 		pmap_kremove((vm_offset_t) addr);
 		vm_page_unhold(PHYS_TO_VM_PAGE(pa));
 	}
-	mtx_unlock(&vm_mtx);
 
 	bp->b_data = bp->b_saveaddr;
 }
@@ -582,17 +581,12 @@
 	 * pages because doing so may flush our L1 and L2 caches too much.
 	 */
 
-	if (mtx_trylock(&vm_mtx) == 0)
-		return (0);
-	if (zero_state && vm_page_zero_count >= ZIDLE_LO(cnt.v_free_count)) {
-		mtx_unlock(&vm_mtx);
+	if (zero_state && vm_page_zero_count >= ZIDLE_LO(cnt.v_free_count))
 		return(0);
-	}
-	if (vm_page_zero_count >= ZIDLE_HI(cnt.v_free_count)) {
-		mtx_unlock(&vm_mtx);
+	if (vm_page_zero_count >= ZIDLE_HI(cnt.v_free_count))
 		return(0);
-	}
 
+	if (mtx_trylock(&Giant)) {
 		zero_state = 0;
 		m = vm_page_list_find(PQ_FREE, free_rover, FALSE);
 		if (m != NULL && (m->flags & PG_ZERO) == 0) {
@@ -611,8 +605,9 @@
 				zero_state = 1;
 		}
 		free_rover = (free_rover + PQ_PRIME2) & PQ_L2_MASK;
-		mtx_unlock(&vm_mtx);
 		return (1);
+	}
+	return(0);
 }
 
 /*
Index: i386/isa/isa_dma.c
===================================================================
RCS file: /home/ncvs/src/sys/i386/isa/isa_dma.c,v
retrieving revision 1.8
diff -u -r1.8 isa_dma.c
--- i386/isa/isa_dma.c	2001/06/30 05:29:08	1.8
+++ i386/isa/isa_dma.c	2001/07/04 02:54:15
@@ -53,6 +53,7 @@
 #include <sys/kernel.h>
 #include <sys/malloc.h>
 #include <sys/lock.h>
+#include <sys/proc.h>
 #include <sys/mutex.h>
 #include <sys/module.h>
 #include <vm/vm.h>
@@ -216,6 +217,8 @@
 	int waport;
 	caddr_t newaddr;
 
+	GIANT_REQUIRED;
+
 #ifdef DIAGNOSTIC
 	if (chan & ~VALID_DMA_MASK)
 		panic("isa_dmastart: channel out of range");
@@ -254,12 +257,7 @@
 	}
 
 	/* translate to physical */
-	mtx_lock(&vm_mtx);	/*
-				 * XXX: need to hold for longer period to
-				 * ensure that mappings don't change
-				 */
 	phys = pmap_extract(pmap_kernel(), (vm_offset_t)addr);
-	mtx_unlock(&vm_mtx);
 
 	if (flags & ISADMA_RAW) {
 	    dma_auto_mode |= (1 << chan);
@@ -378,11 +376,11 @@
 	vm_offset_t phys, priorpage = 0, endva;
 	u_int dma_pgmsk = (chan & 4) ?  ~(128*1024-1) : ~(64*1024-1);
 
+	GIANT_REQUIRED;
+
 	endva = (vm_offset_t)round_page((vm_offset_t)va + length);
 	for (; va < (caddr_t) endva ; va += PAGE_SIZE) {
-		mtx_lock(&vm_mtx);
 		phys = trunc_page(pmap_extract(pmap_kernel(), (vm_offset_t)va));
-		mtx_unlock(&vm_mtx);
 #define ISARAM_END	RAM_END
 		if (phys == 0)
 			panic("isa_dmacheck: no physical page present");
Index: kern/imgact_aout.c
===================================================================
RCS file: /home/ncvs/src/sys/kern/imgact_aout.c,v
retrieving revision 1.68
diff -u -r1.68 imgact_aout.c
--- kern/imgact_aout.c	2001/05/19 01:28:02	1.68
+++ kern/imgact_aout.c	2001/07/04 02:54:15
@@ -91,6 +91,8 @@
 	unsigned long bss_size;
 	int error;
 
+	GIANT_REQUIRED;
+
 	/*
 	 * Linux and *BSD binaries look very much alike,
 	 * only the machine id is different:
@@ -171,7 +173,6 @@
 	if (error)
 		return (error);
 
-	mtx_lock(&vm_mtx);
 	/*
 	 * Destroy old process VM and create a new one (with a new stack)
 	 */
@@ -185,9 +186,7 @@
 	vp = imgp->vp;
 	map = &vmspace->vm_map;
 	vm_map_lock(map);
-	mtx_unlock(&vm_mtx);
 	VOP_GETVOBJECT(vp, &object);
-	mtx_lock(&vm_mtx);
 	vm_object_reference(object);
 
 	text_end = virtual_offset + a_out->a_text;
@@ -198,7 +197,6 @@
 		MAP_COPY_ON_WRITE | MAP_PREFAULT);
 	if (error) {
 		vm_map_unlock(map);
-		mtx_unlock(&vm_mtx);
 		return (error);
 	}
 	data_end = text_end + a_out->a_data;
@@ -211,7 +209,6 @@
 			MAP_COPY_ON_WRITE | MAP_PREFAULT);
 		if (error) {
 			vm_map_unlock(map);
-			mtx_unlock(&vm_mtx);
 			return (error);
 		}
 	}
@@ -222,7 +219,6 @@
 			VM_PROT_ALL, VM_PROT_ALL, 0);
 		if (error) {
 			vm_map_unlock(map);
-			mtx_unlock(&vm_mtx);
 			return (error);
 		}
 	}
@@ -234,8 +230,6 @@
 	vmspace->vm_taddr = (caddr_t) (uintptr_t) virtual_offset;
 	vmspace->vm_daddr = (caddr_t) (uintptr_t)
 			    (virtual_offset + a_out->a_text);
-
-	mtx_unlock(&vm_mtx);
 
 	/* Fill in image_params */
 	imgp->interpreted = 0;
Index: kern/imgact_elf.c
===================================================================
RCS file: /home/ncvs/src/sys/kern/imgact_elf.c,v
retrieving revision 1.95
diff -u -r1.95 imgact_elf.c
--- kern/imgact_elf.c	2001/05/23 22:05:08	1.95
+++ kern/imgact_elf.c	2001/07/04 02:54:15
@@ -198,6 +198,8 @@
 	vm_offset_t file_addr;
 	vm_offset_t data_buf = 0;
 
+	GIANT_REQUIRED;
+
 	VOP_GETVOBJECT(vp, &object);
 	error = 0;
 
@@ -230,7 +232,6 @@
 	else
 		map_len = round_page(offset+filsz) - file_addr;
 
-	mtx_lock(&vm_mtx);
 	if (map_len != 0) {
 		vm_object_reference(object);
 		vm_map_lock(&vmspace->vm_map);
@@ -245,13 +246,11 @@
 		vm_map_unlock(&vmspace->vm_map);
 		if (rv != KERN_SUCCESS) {
 			vm_object_deallocate(object);
-			mtx_unlock(&vm_mtx);
 			return EINVAL;
 		}
 
 		/* we can stop now if we've covered it all */
 		if (memsz == filsz) {
-			mtx_unlock(&vm_mtx);
 			return 0;
 		}
 	}
@@ -275,7 +274,6 @@
 					VM_PROT_ALL, VM_PROT_ALL, 0);
 		vm_map_unlock(&vmspace->vm_map);
 		if (rv != KERN_SUCCESS) {
-			mtx_unlock(&vm_mtx);
 			return EINVAL; 
 		}	
 	}
@@ -293,17 +291,13 @@
 				 MAP_COPY_ON_WRITE | MAP_PREFAULT_PARTIAL);
 		if (rv != KERN_SUCCESS) {
 			vm_object_deallocate(object);
-			mtx_unlock(&vm_mtx);
 			return EINVAL;
 		}
 
 		/* send the page fragment to user space */
-		mtx_unlock(&vm_mtx);
 		error = copyout((caddr_t)data_buf, (caddr_t)map_addr, copy_len);
-		mtx_lock(&vm_mtx);
 		vm_map_remove(exec_map, data_buf, data_buf + PAGE_SIZE);
 		if (error) {
-			mtx_unlock(&vm_mtx);
 			return (error);
 		}
 	}
@@ -314,7 +308,6 @@
 	vm_map_protect(&vmspace->vm_map, map_addr, map_addr + map_len,  prot,
 		       FALSE);
 
-	mtx_unlock(&vm_mtx);
 	return error;
 }
 
@@ -475,6 +468,8 @@
 	Elf_Brandinfo *brand_info;
 	char path[MAXPATHLEN];
 
+	GIANT_REQUIRED;
+
 	/*
 	 * Do we have a valid ELF header ?
 	 */
@@ -510,11 +505,9 @@
 	if ((error = exec_extract_strings(imgp)) != 0)
 		goto fail;
 
-	mtx_lock(&vm_mtx);
 	exec_new_vmspace(imgp);
 
 	vmspace = imgp->proc->p_vmspace;
-	mtx_unlock(&vm_mtx);
 
 	for (i = 0; i < hdr->e_phnum; i++) {
 		switch(phdr[i].p_type) {
@@ -571,12 +564,10 @@
 		}
 	}
 
-	mtx_lock(&vm_mtx);
 	vmspace->vm_tsize = text_size >> PAGE_SHIFT;
 	vmspace->vm_taddr = (caddr_t)(uintptr_t)text_addr;
 	vmspace->vm_dsize = data_size >> PAGE_SHIFT;
 	vmspace->vm_daddr = (caddr_t)(uintptr_t)data_addr;
-	mtx_unlock(&vm_mtx);
 
 	addr = ELF_RTLD_ADDR(vmspace);
 
Index: kern/init_main.c
===================================================================
RCS file: /home/ncvs/src/sys/kern/init_main.c,v
retrieving revision 1.173
diff -u -r1.173 init_main.c
--- kern/init_main.c	2001/06/13 10:58:36	1.173
+++ kern/init_main.c	2001/07/04 02:54:15
@@ -274,6 +274,8 @@
 	register struct filedesc0	*fdp;
 	register unsigned i;
 
+	GIANT_REQUIRED;
+
 	p = &proc0;
 
 	/*
@@ -373,14 +375,12 @@
 	limit0.p_refcnt = 1;
 
 	/* Allocate a prototype map so we have something to fork. */
-	mtx_lock(&vm_mtx);
 	pmap_pinit0(vmspace_pmap(&vmspace0));
 	p->p_vmspace = &vmspace0;
 	vmspace0.vm_refcnt = 1;
 	vm_map_init(&vmspace0.vm_map, round_page(VM_MIN_ADDRESS),
 	    trunc_page(VM_MAXUSER_ADDRESS));
 	vmspace0.vm_map.pmap = vmspace_pmap(&vmspace0);
-	mtx_unlock(&vm_mtx);
 	p->p_addr = proc0paddr;				/* XXX */
 
 	/*
@@ -471,6 +471,8 @@
 
 	mtx_lock(&Giant);
 
+	GIANT_REQUIRED;
+
 	p = curproc;
 
 	/* Get the vnode for '/'.  Set p->p_fd->fd_cdir to reference it. */
@@ -486,13 +488,11 @@
 	 * Need just enough stack to hold the faked-up "execve()" arguments.
 	 */
 	addr = trunc_page(USRSTACK - PAGE_SIZE);
-	mtx_lock(&vm_mtx);
 	if (vm_map_find(&p->p_vmspace->vm_map, NULL, 0, &addr, PAGE_SIZE,
 			FALSE, VM_PROT_ALL, VM_PROT_ALL, 0) != 0)
 		panic("init: couldn't allocate argument space");
 	p->p_vmspace->vm_maxsaddr = (caddr_t)addr;
 	p->p_vmspace->vm_ssize = 1;
-	mtx_unlock(&vm_mtx);
 
 	if ((var = getenv("init_path")) != NULL) {
 		strncpy(init_path, var, sizeof init_path);
Index: kern/kern_exec.c
===================================================================
RCS file: /home/ncvs/src/sys/kern/kern_exec.c,v
retrieving revision 1.132
diff -u -r1.132 kern_exec.c
--- kern/kern_exec.c	2001/06/20 23:10:06	1.132
+++ kern/kern_exec.c	2001/07/04 02:54:15
@@ -445,13 +445,13 @@
 	vm_page_t ma[VM_INITIAL_PAGEIN];
 	vm_object_t object;
 
+	GIANT_REQUIRED;
 
 	if (imgp->firstpage) {
 		exec_unmap_first_page(imgp);
 	}
 
 	VOP_GETVOBJECT(imgp->vp, &object);
-	mtx_lock(&vm_mtx);
 
 	ma[0] = vm_page_grab(object, 0, VM_ALLOC_NORMAL | VM_ALLOC_RETRY);
 
@@ -482,7 +482,6 @@
 				vm_page_protect(ma[0], VM_PROT_NONE);
 				vm_page_free(ma[0]);
 			}
-			mtx_unlock(&vm_mtx);
 			return EIO;
 		}
 	}
@@ -493,7 +492,6 @@
 	pmap_kenter((vm_offset_t) imgp->image_header, VM_PAGE_TO_PHYS(ma[0]));
 	imgp->firstpage = ma[0];
 
-	mtx_unlock(&vm_mtx);
 	return 0;
 }
 
@@ -501,12 +499,11 @@
 exec_unmap_first_page(imgp)
 	struct image_params *imgp;
 {
+	GIANT_REQUIRED;
 
 	if (imgp->firstpage) {
-		mtx_lock(&vm_mtx);
 		pmap_kremove((vm_offset_t) imgp->image_header);
 		vm_page_unwire(imgp->firstpage, 1);
-		mtx_unlock(&vm_mtx);
 		imgp->firstpage = NULL;
 	}
 }
@@ -525,7 +522,8 @@
 	caddr_t	stack_addr = (caddr_t) (USRSTACK - MAXSSIZ);
 	vm_map_t map = &vmspace->vm_map;
 
-	mtx_assert(&vm_mtx, MA_OWNED);
+	GIANT_REQUIRED;
+
 	imgp->vmspace_destroyed = 1;
 
 	/*
Index: kern/kern_exit.c
===================================================================
RCS file: /home/ncvs/src/sys/kern/kern_exit.c,v
retrieving revision 1.129
diff -u -r1.129 kern_exit.c
--- kern/kern_exit.c	2001/06/27 06:15:44	1.129
+++ kern/kern_exit.c	2001/07/04 02:54:15
@@ -120,6 +120,8 @@
 	register struct vmspace *vm;
 	struct exitlist *ep;
 
+	GIANT_REQUIRED;
+
 	if (p->p_pid == 1) {
 		printf("init died (signal %d, exit %d)\n",
 		    WTERMSIG(rv), WEXITSTATUS(rv));
@@ -213,7 +215,6 @@
 	 * Can't free the entire vmspace as the kernel stack
 	 * may be mapped within that space also.
 	 */
-	mtx_lock(&vm_mtx);
 	if (vm->vm_refcnt == 1) {
 		if (vm->vm_shm)
 			shmexit(p);
@@ -222,7 +223,6 @@
 		(void) vm_map_remove(&vm->vm_map, VM_MIN_ADDRESS,
 		    VM_MAXUSER_ADDRESS);
 	}
-	mtx_unlock(&vm_mtx);
 
 	PROC_LOCK(p);
 	if (SESS_LEADER(p)) {
Index: kern/kern_fork.c
===================================================================
RCS file: /home/ncvs/src/sys/kern/kern_fork.c,v
retrieving revision 1.115
diff -u -r1.115 kern_fork.c
--- kern/kern_fork.c	2001/06/30 03:35:22	1.115
+++ kern/kern_fork.c	2001/07/04 02:54:15
@@ -209,6 +209,8 @@
 	struct forklist *ep;
 	struct filedesc *fd;
 
+	GIANT_REQUIRED;
+
 	/* Can't copy and clear */
 	if ((flags & (RFFDG|RFCFDG)) == (RFFDG|RFCFDG))
 		return (EINVAL);
@@ -218,9 +220,7 @@
 	 * certain parts of a process from itself.
 	 */
 	if ((flags & RFPROC) == 0) {
-
 		vm_fork(p1, 0, flags);
-		mtx_assert(&vm_mtx, MA_NOTOWNED);
 
 		/*
 		 * Close all file descriptors.
@@ -561,7 +561,6 @@
 	 * execution path later.  (ie: directly into user mode)
 	 */
 	vm_fork(p1, p2, flags);
-	mtx_assert(&vm_mtx, MA_NOTOWNED);
 
 	if (flags == (RFFDG | RFPROC)) {
 		cnt.v_forks++;
Index: kern/kern_resource.c
===================================================================
RCS file: /home/ncvs/src/sys/kern/kern_resource.c,v
retrieving revision 1.83
diff -u -r1.83 kern_resource.c
--- kern/kern_resource.c	2001/05/19 01:28:02	1.83
+++ kern/kern_resource.c	2001/07/04 02:54:15
@@ -431,6 +431,8 @@
 	register struct rlimit *alimp;
 	int error;
 
+	GIANT_REQUIRED;
+
 	if (which >= RLIM_NLIMITS)
 		return (EINVAL);
 	alimp = &p->p_rlimit[which];
@@ -498,10 +500,8 @@
 			}
 			addr = trunc_page(addr);
 			size = round_page(size);
-			mtx_lock(&vm_mtx);
 			(void) vm_map_protect(&p->p_vmspace->vm_map,
 					      addr, addr+size, prot, FALSE);
-			mtx_unlock(&vm_mtx);
 		}
 		break;
 
Index: kern/link_elf.c
===================================================================
RCS file: /home/ncvs/src/sys/kern/link_elf.c,v
retrieving revision 1.38
diff -u -r1.38 link_elf.c
--- kern/link_elf.c	2001/06/13 10:58:36	1.38
+++ kern/link_elf.c	2001/07/04 02:54:15
@@ -531,6 +531,8 @@
     int symcnt;
     int strcnt;
 
+    GIANT_REQUIRED;
+
     shdr = NULL;
     lf = NULL;
 
@@ -657,10 +659,8 @@
 
     ef = (elf_file_t) lf;
 #ifdef SPARSE_MAPPING
-    mtx_lock(&vm_mtx);
     ef->object = vm_object_allocate(OBJT_DEFAULT, mapsize >> PAGE_SHIFT);
     if (ef->object == NULL) {
-    	mtx_unlock(&vm_mtx);
 	free(ef, M_LINKER);
 	error = ENOMEM;
 	goto out;
@@ -673,11 +673,9 @@
 			VM_PROT_ALL, VM_PROT_ALL, 0);
     if (error) {
 	vm_object_deallocate(ef->object);
-    	mtx_unlock(&vm_mtx);
 	ef->object = 0;
 	goto out;
     }
-    mtx_unlock(&vm_mtx);
 #else
     ef->address = malloc(mapsize, M_LINKER, M_WAITOK);
     if (!ef->address) {
@@ -705,12 +703,10 @@
 	/*
 	 * Wire down the pages
 	 */
-	mtx_lock(&vm_mtx);
 	vm_map_pageable(kernel_map,
 			(vm_offset_t) segbase,
 			(vm_offset_t) segbase + segs[i]->p_memsz,
 			FALSE);
-	mtx_unlock(&vm_mtx);
 #endif
     }
 
@@ -834,12 +830,10 @@
     }
 #ifdef SPARSE_MAPPING
     if (ef->object) {
-	mtx_lock(&vm_mtx);	    
 	vm_map_remove(kernel_map, (vm_offset_t) ef->address,
 		      (vm_offset_t) ef->address
 		      + (ef->object->size << PAGE_SHIFT));
 	vm_object_deallocate(ef->object);
-	mtx_unlock(&vm_mtx);	    
     }
 #else
     if (ef->address)
Index: kern/subr_blist.c
===================================================================
RCS file: /home/ncvs/src/sys/kern/subr_blist.c,v
retrieving revision 1.8
diff -u -r1.8 subr_blist.c
--- kern/subr_blist.c	2001/05/19 01:28:02	1.8
+++ kern/subr_blist.c	2001/07/04 02:54:15
@@ -71,6 +71,7 @@
 #include <sys/kernel.h>
 #include <sys/blist.h>
 #include <sys/malloc.h>
+#include <sys/proc.h>
 #include <sys/mutex.h> 
 #include <vm/vm.h>
 #include <vm/vm_object.h>
